/' (c) 2022 cepstrum.co.jp           '/
/' This is not free software.        '/

#include "portaudio.bi"

#inclib "mix_c"

extern "C"
declare sub adp_emp(x as single, byref y as single) 
end extern

#define FS        8000
#define PA_BUFLEN 1

type User_Data_Type
  frame_count as integer
end type

dim user_data as User_Data_Type

dim stream           as any ptr 
dim errcode          as integer<32>

dim now_time         as string
dim past_time        as string
dim past_frame_count as integer

dim inchar           as string
dim keycode          as integer

'==========================================================================

function callbackfunc cdecl(                    _
  pread       as integer<16> ptr,               _
  pwrite      as integer<16> ptr,               _
  rwcount     as uinteger<32>,                  _
  timeInfo    as PaStreamCallbackTimeInfo ptr,  _
  flag        as uinteger<32>,                  _
  puser_data  as User_Data_Type ptr             _
) as integer

  static frame_counter as integer = 0

  dim i_ad as integer<16>
  dim i_da as integer<16>
  dim f_ad as single
  dim f_da as single

  i_ad=*pread
  f_ad=i_ad/32768.0
  
  adp_emp(f_ad, f_da)      ' call external c function in DLL
  'f_da=f_ad               ' through pass

  i_da=int(f_da*32768.0)   ' int() : floor function
  *pwrite=i_da

  frame_counter=frame_counter+1
  (puser_data->frame_count)=frame_counter

  return 0

end function

'==========================================================================

errcode=Pa_Initialize()

errcode=Pa_OpenDefaultStream(  _ 
  @stream,                     _  ' PaStream ptr ptr        
  1,                           _  ' input channels          
  1,                           _  ' output channels       
  8,                           _  ' sample format (paInt16)  
  FS,                          _  ' Fs                   
  PA_BUFLEN,                   _  ' frames per buffer     
  @callbackfunc,               _  ' callback function  
  @user_data                   _  ' user data      
) 

errcode=Pa_StartStream(stream)

past_time=""
past_frame_count=0
do
  inchar=inkey$
  keycode=asc(inchar)
  if keycode=3 or keycode=27 then           ' if ctrl-C or ESC
    errcode=Pa_StopStream(stream)
    errcode=Pa_CloseStream(stream)
    Pa_Terminate()
    system
  end if

  now_time=time
  if now_time<>past_time then
    print "hit ctrl-C or ESC key to exit"; " "; time; user_data.frame_count; user_data.frame_count-past_frame_count;   
    print using "##.##%"; 100.0*Pa_GetStreamCpuLoad(stream)                      
    past_frame_count=user_data.frame_count
  end if
  past_time=now_time
loop


